'------------------------------------------------------------------------
'  ExternalIP.vbs (v1.4)
'------------------------------------------------------------------------
'
' Retreives your external IP address from http://www.ansutek.co.nz/IP.SHTML
' (this is useful for computers behind routers and firewalls)
'
' Suitable for NZ users as it uses national traffic to check your IP :)
'
'
' Changes in v1.4
'
' - internet connection detected (thanks AdamC)
'
' Changes in v1.2:
'
' - made code easier to understand & shorter :)
'
' Changes in v1.1:
'
' - Added error messages
' - Hid relevant functions from Samurize 0.85b
'
'								- NeM
'------------------------------------------------------------------------

Const CheckConnected      = True                            ' Whether you want the script to check if its connected to the internet
                                                            ' Either True of False


Function getExternalIP


	dim htmlResult,output
        
        'Check that Computer is connected to the internet
	Connected = IsConnectible("checkip.dyndns.org","","")	
        
        if Connected = True OR CheckConnected = False then
        
                htmlResult = ReturnHTML("http://www.ansutek.co.nz/IP.SHTML")
                output = NULL

                relnext = instr(htmlResult, "This part gets the IP")

                if relnext > 0 then
		
                        leftPos = instr( htmlResult, "var ip = '") + 10
                        rightPos = instr( leftPos, htmlResult, "';")

                        if leftPos > 0 AND rightPos > leftPos Then

                                'grabs the IP
                                getExternalIP = mid( htmlResult, leftPos, rightPos - leftPos)

                        else 
                                getExternalIP = "ERROR"

                        end if

                else
                        getExternalIP = "Website error"

                end if

	Else
		getExternalIP = "Offline"
	End If

End Function

Private Function ReturnHTML(sURL)
	Dim objXMLHTTP,HTML
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	HTML = objXMLHTTP.responseBody
	Set objRS = CreateObject("ADODB.Recordset")
	objRS.Fields.Append "txt", 200, 45000, &H00000080
	objRS.Open
	objRS.AddNew
	objRS.Fields("txt").AppendChunk HTML
	ReturnHTML = objRS("txt").Value
	objRS.Close
	Set objRS = Nothing
	Set objXMLHTTP = Nothing
End Function


' This was done by someone on the forums which I copied, and can I find that post again can I heck
' So who every you are thanks for the cold.
Private Function IsConnectible(sHost,iPings,iTO)
	' Works an "all" WSH versions
	' sHost is a hostname or IP

	' iPings is number of ping attempts
	' iTO is timeout in milliseconds
	' if values are set to "", then defaults below used

	 If iPings = "" Then iPings = 2
	 If iTO = "" Then iTO = 750
	
	 Const OpenAsDefault    = -2
	 Const FailIfNotExist   =  0
	 Const ForReading       =  1
	
	 Set oShell = CreateObject("WScript.Shell")
	 Set oFSO = CreateObject("Scripting.FileSystemObject")
	 sTemp = oShell.ExpandEnvironmentStrings("%TEMP%")
	 sTempFile = sTemp & "\runresult.tmp"

	 oShell.Run "%comspec% /c ping -n " & iPings & " -w " & iTO & " " & sHost & ">" & sTempFile, 0 , True
	
	 Set fFile = oFSO.OpenTextFile(sTempFile, ForReading, FailIfNotExist, OpenAsDefault)

	 sResults = fFile.ReadAll
	 fFile.Close
	 oFSO.DeleteFile(sTempFile)
	
	 Select Case InStr(sResults,"TTL=")
	   Case 0 IsConnectible = False
	   Case Else IsConnectible = True
	 End Select
End Function